﻿using System;
using System.Collections.Generic;
using System.Linq;
using CharMY.IO;

namespace CharMY.Sample
{
    partial class Sample
    {
        //クロス集計

        [STAThread]
        public static void Main()
        {
            Consoles.Initialize();

            var rand = new Random(7);
            var data = Enumerable
                .Range(0, 100)
                .Select(_ => TypeInference.Array(
                    rand.Next(10, 13).ToString(),
                    rand.Next(11, 15).ToString(),
                    rand.Next(12, 17).ToString(),
                    rand.Next(13, 19).ToString()
                ))
                .ToArray();

            CrossMatrix(data);

            Console.ReadLine();
        }

        private static void CrossMatrix(IEnumerable<string[]> table)
        {
            Console.WriteLine("個数のクロス集計");
            var cross_matrix_1 = table
                .CountGroup(record => record[0], record => record[1]);

            Console.WriteLine(cross_matrix_1.Select(item => item.Key.Outer + " & " + item.Key.Inner + " = " + item.Value));
            Console.WriteLine();

            Console.WriteLine("合計のクロス集計");
            var cross_matrix_2 = table
                .SumGroup(record => record[0], record => record[1], record => record[3].To(0.0));

            Console.WriteLine(cross_matrix_2.Select(item => item.Key.Outer + " & " + item.Key.Inner + " = " + item.Value));
            Console.WriteLine();

            Console.WriteLine("平均のクロス集計");
            var cross_matrix_3 = table
                .AverageGroup(record => record[0], record => record[1], record => record[3].To(0.0));

            Console.WriteLine(cross_matrix_3.Select(item => item.Key.Outer + " & " + item.Key.Inner + " = " + item.Value));

            Console.WriteLine("分散のクロス集計");
            var cross_matrix_4 = table
                .VarianceGroup(record => record[0], record => record[1], record => record[3].To(0.0));

            Console.WriteLine(cross_matrix_4.Select(item => item.Key.Outer + " & " + item.Key.Inner + " = " + item.Value));
            Console.WriteLine();
        }
    }
}
