﻿using System;
using System.Linq;
using CharMY.Analysis;
using CharMY.Analysis.Estimation;
using CharMY.Data;
using CharMY.IO;
using CharMY.Reflection;

namespace CharMY.Sample
{
    partial class Sample
    {
        //重回帰分析

        [STAThread]
        public static void Main()
        {
            Consoles.Initialize();
            MultipleRegressionUpdateResult();
            Console.ReadLine();
        }

        [CuiTest]
        public static void MultipleRegressionUpdateResult()
        {
            var table = new DataTable("reg");
            var columns = TypeInference.Array("A", "B", "Y")
                .Select(name => table.AddColumn<double>(name))
                .Select(col => col.Items)
                .ToArray();

            {
                var file = Files.ExeFile
                    .Directory.GetRelativeFile("../../../test-data/multiple-regression-data.csv");

                Console.WriteLine(file.ToInformation());

                Files.Csv().LoadTable(file, table: table);

                Console.WriteLine(table.Columns);
            }

            var sta = new StatisticalArrays(columns);
            var reg = new MultipleRegression(sta);
            reg.UpdateResult();
            reg.Result.WriteResult(Consoles.TableWriter);
        }
        [CuiTest]
        public static void MultipleRegressionUpdateResultW()
        {
            var file = Files.ExeFile
                .Directory.GetRelativeFile("../../../test-data/multiple-regression-w-data.csv");

            var records = Files.Csv().LoadRecords(file);
            var sta = records
                .CalculateStatisticalValues(
                    (rec, name, i) => rec.Get(name, double.NaN),
                    rec => rec.Get("W", 0.0),
                    "A", "B", "Y"
                );

            var reg = sta.MultipleRegression();
            reg.UpdateResult();
            reg.Result.WriteResult(Consoles.TableWriter);
        }
    }
}
