﻿using System;
using System.Linq;
using CharMY.Analysis;
using CharMY.IO;
using CharMY.Numerics;
using CharMY.Text;

namespace CharMY.Sample
{
    partial class Sample
    {
        //高速フーリエ変換

        [STAThread]
        public static void Main()
        {
            Consoles.Initialize();

            var format = NumberFormats.DefaultFloat;
            var rand = new Random(7);
            var fn = rand
                .GetDoubles()
                .Select((d, i) => new Complex<double>
                    (Math.Sin(i) + Math.Sin(i * 20) + d, 0))
                .Take(32)
                .ToArray();

            Console.WriteLine(fn.Select((f, i) => i + " : " + f.ToString(format)));
            Console.WriteLine(" = 元データ");
            Console.WriteLine();


            //高速フーリエ変換
            var Fk = fn.FourierTransform();
            Console.WriteLine(Fk.Select((f, i) => i + " : " + f.ToString(format)));
            Console.WriteLine(" = フーリエ変換後");
            Console.WriteLine();


            //逆変換
            var reversed = Fk.FourierTransform(true);
            Console.WriteLine(reversed.Zip(fn, (rev, origin) => origin.ToString(format) + " >>> " + rev.ToString(format)));
            Console.WriteLine(" = 元に戻った？");
            Console.WriteLine();


            Console.WriteLine(Fk.Select((c, i) => i + ": " + (c.Magnitude * c.Magnitude / Fk.Dim)));
            Console.WriteLine(" = パワースペクトル");
            Console.ReadLine();
        }
    }
}
