﻿using System;
using System.Linq;
using CharMY.Analysis.Estimation;
using CharMY.IO;

namespace CharMY.Sample
{
    partial class Sample
    {
        //滑降シンプレックス法による最小値パラメータ推定

        [STAThread]
        public static void Main()
        {
            Consoles.Initialize();

            var function = new ExpressionFunction<double>((x, y) => (x + 1) * (x + 2) + (y - 2) * (y - 3));
            Console.WriteLine(function.Model.Name);

            Console.WriteLine(function.Parameters
                .Select(param => param.Value)
                .ToStrings());

            Console.WriteLine(function.CalculateCost());

            var estimator = new DownhillSimplexMethod<double>(function);
            estimator.CalculationCount = 20;
            estimator.UpdateResult();
            estimator.Result
                .WriteResult(Consoles.TableWriter);

            Console.ReadLine();
        }
    }
}
