﻿using System;
using System.Linq.Expressions;
using CharMY.Collections.Generic;
using CharMY.IO;
using CharMY.Linq.Expressions;
using CharMY.Numerics.Matrixes;
using CharMY.Reflection;

namespace CharMY.Sample
{
    partial class Sample
    {
        //行列計算：特異値分解による一般化逆行列

        [STAThread]
        public static void Main()
        {
            Consoles.Initialize();

            GeneralInverseText();

            Console.ReadLine();
        }


        [CuiTest]
        public static void GeneralInverseText()
        {
            int aa = 8;
            bool bb = false;
            Expression<Func<int>> a = () => ~aa;
            Expression<Func<bool>> b = () => !bb;
            Console.WriteLine(a.ToProgrammingCodetionText());
            Console.WriteLine(b.ToProgrammingCodetionText());

            int dimJ = 7;
            int dimI = dimJ - 2;
            var A = new double[dimI, dimJ].ToAssignableMatrix();
            var B = new double[dimJ, dimJ].ToAssignableMatrix();
            var AInv = A.AsMatrix ^ -1;
            var AAInv = A.AsMatrix & AInv;
            var AInvA = AInv & A.AsMatrix;

            var AB = A.AsMatrix & B.AsMatrix;

            var rand = new Random(73);
            for (int n = 0 ; n < 10000 ; ++n)
            {
                for (int i = 0 ; i < dimI ; ++i)
                    for (int j = 0 ; j < dimJ ; ++j)
                        A[i, j] = (rand.Next(-2, 5) / 2);
                for (int i = 0 ; i < dimJ ; ++i)
                    for (int j = 0 ; j < dimJ ; ++j)
                        B[i, j] = (rand.Next(-2, 5) / 2);

                if (n >= 0)
                {
                    WriteLine(() => B, true);
                    WriteLine(() => AB);
                    WriteLine(() => ~AB);

                    WriteLine(() => A, true);
                    WriteLine(() => AInv);
                    WriteLine(() => AAInv);
                    WriteLine(() => AInvA);

                    Console.ReadLine();
                }
            }

        }
        public static void WriteLine(Expression<Func<IMatrix>> matrix, bool separator = false)
        {
            if (matrix == null)
                return;

            var value = matrix.Compile()();
            if (value == null)
                return;

            if (separator)
                Console.WriteLine("_".Cache().Repeat(11 * value.DimJ).ToSingleString());

            var type = value.GetType();
            Console.WriteLine(
                matrix.Body.ToProgrammingCodetionText()
                + " : " + value.ToString()
                + "  (" + type.ToTypeString() + ") = ");
            Console.WriteLine(value);
            Console.WriteLine();
        }
    }
}
