﻿using System;
using CharMY.Numerics._Dimensions;
using CharMY.Numerics.Matrixes;
using CharMY.Reflection;
using CharMY.IO;

namespace CharMY.Sample
{
    partial class Sample
    {
        //行列計算（GENERIC行列クラスの利用）

        [STAThread]
        [CuiTest]
        public static void Main()
        {
            Consoles.Initialize();
            Assert.NotNull(OperationInfoMatrixCore<Matrix<double>, double>.Info);
            Assert.NotNull(OperationInfoMatrixCore<Matrix<double>.Generl, double>.Info);
            Assert.NotNull(OperationInfoMatrixCore<Matrix<double>.Generl.Dim<_2, _3>, double>.Info);

            Matrix<double>.Generl.Dim<_2, _3>
                mat23_a = MatrixCreator.Dimensions<_2, _3>().Create
                (null,
                    0.0, 1.0, 0.0,
                    2.0, 0.0, 0.0
                ),
                mat23_b = MatrixCreator.Dimensions<_2, _3>().Create<double>();
            Matrix<double>.Generl.Dim<_3, _2>
                mat32 = MatrixCreator.Dimensions<_3, _2>().Create
                (null,
                    0.0, 1.0,
                    2.0, 0.0,
                    0.0, 3.0
                );

            WriteType(() => ~mat23_a + ~mat23_a);
            WriteType(() => mat23_a + mat23_b);
            WriteType(() => mat23_a + (mat23_b as Matrix<double>.Generl));
            WriteType(() => mat23_a + (mat23_b as Matrix<double>));

            //WriteType(() => mat23_a + mat32); error

            WriteType(() => mat23_a & mat32);
            WriteType(() => mat32 & mat23_a);

            Console.ReadLine();
        }
        private static void WriteType<T>(Func<T> f)
        {
            Console.WriteLine(typeof(T).ToTypeString(TypeStringFormats.WithDeclaringType));
            Console.WriteLine(f());
        }

    }
}
