﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Dynamic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Net;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Security.Permissions;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;
using CharMY;
using CharMY.Analysis;
using CharMY.Analysis.Estimation;
using CharMY.Analysis.Graphs;
using CharMY.Collections.Generic;
using CharMY.ComponentModel;
using CharMY.Data;
using CharMY.Drawing;
using CharMY.IO;
using CharMY.Linq;
using CharMY.Linq.Expressions;
using CharMY.Net;
using CharMY.Numerics;
using CharMY.Numerics._Dimensions;
using CharMY.Numerics.Matrixes;
using CharMY.Reflection;
using CharMY.Resources;
using CharMY.Runtime.Serialization;
using CharMY.Text;
using CharMY.Windows.Forms;
using CharMY.Xml;

namespace CharMY.Sample
{
    partial class Sample
    {
        //補間

        [STAThread]
        public static void Main()
        {
            var rand = new Random(7);
            var line = new SearchTreeInterpolated<double, double>();

            var x_range = 10.0;
            var y_range = 10.0;
            var last_y = rand.NextDouble() * y_range;
            //元データを作成（5プロット）
            for (int i = 0 ; i < 5 ; ++i)
            {
                line[rand.NextDouble() * x_range] = last_y
                    = (rand.NextDouble() * y_range).Limit(0.0, y_range);
            }

            var points = Sequence.For(-1.0, d => d <= x_range + 1.0, d => d + 0.2);

            {
                //スプライン補間線の作成と描画
                var sp = line.SplineInterpolate();
                var fig = points.ChartPlot(
                    p => p,
                    p => sp[p],
                    coloringValue: p =>
                    {
                        KeyValuePair<double, double> pair;
                        line.TryGetNearest(p, out pair);
                        return Math.Abs(pair.Key - p);
                    },
                    xLabel: "x",
                    yLabel: "y");

                fig.Axes.Y().MaximumValue = y_range + y_range;
                fig.Axes.Y().MinimumValue = 0.0 - y_range;

                fig.ImageView()
                    .ShowDialog();
            }

            //ラグランジュ補間線（0次～4次）の作成と描画
            for (int ii = 0 ; ii < 5 ; ++ii)
            {
                line.InterpolatingDimension = ii;
                var fig = points.ChartPlot(
                    p => p,
                    p => line[p],
                    coloringValue: p =>
                    {
                        KeyValuePair<double, double> pair;
                        line.TryGetNearest(p, out pair);
                        return Math.Abs(pair.Key - p);
                    },
                    xLabel: "x",
                    yLabel: "y");

                fig.Axes.Y().MaximumValue = y_range + y_range;
                fig.Axes.Y().MinimumValue = 0.0 - y_range;

                fig.ImageView()
                    .ShowDialog();
            }
        }
    }
}
