﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Dynamic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Net;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Runtime.Serialization;
using System.Security.Permissions;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;
using CharMY;
using CharMY.Analysis;
using CharMY.Analysis.Estimation;
using CharMY.Analysis.Graphs;
using CharMY.Collections.Generic;
using CharMY.ComponentModel;
using CharMY.Data;
using CharMY.Drawing;
using CharMY.IO;
using CharMY.Linq;
using CharMY.Linq.Expressions;
using CharMY.Net;
using CharMY.Numerics;
using CharMY.Numerics._Dimensions;
using CharMY.Numerics.Matrixes;
using CharMY.Reflection;
using CharMY.Resources;
using CharMY.Runtime.Serialization;
using CharMY.Text;
using CharMY.Windows.Forms;
using CharMY.Xml;

namespace CharMY.Sample
{
    partial class Sample
    {
        //ドロネー図描画

        [STAThread]
        public static void Main()
        {
            var collection = new DelaunayCollection<Tuple<double, double>>(
                vec => vec.Item1,
                vec => vec.Item2);
            var rand = new Random(7);
            int i = 0;
            for ( ; i < 200 ; ++i)
            {
                Console.WriteLine("ADD: " + i);
                collection.Add
                (
                    Tuple.Create(rand.NextDouble() * 5, rand.NextDouble() * 5)
                );
            }

            var meta = Draw(collection);
            meta
                .ImageView(mouseEvent: e =>
                {
                    if (e.Type == MouseEventType.LeftDown)
                    {
                        collection.Add(Tuple.Create(
                            e.Location.X / 100.0 - 1,
                            e.Location.Y / 100.0 - 1));
                        e.Form.SetImage(Draw(collection));
                    }
                })
                .ShowDialog();
        }
        private static MetaImageBuilder Draw(DelaunayCollection<Tuple<double, double>> collection)
        {
            var s_default = new PenStyle();
            var s_special = new PenStyle();
            s_default.Width = 1.7F;
            s_special.DashPattern = new[] { 3F, 3F };

            float ratio = 100F;
            var meta = new MetaImageBuilder();
            var g = meta.Graphics2D;
            var lines = collection
                .DrawingEdges(0.5)
                .OrderBy(line => line.Item1.SquareDistance(line.Item2))
                .ToArray();

            var rand = new Random();
            foreach (var line in lines)
            {
                var s = (line.Item1.Item == null || line.Item2.Item == null) ? s_special : s_default;
                s_default.Brush.Color = Colors.FromHsv(rand.Next(0, 0x100), 0xFF, 0x40);
                s_default.DashPattern = rand.GetIntegers(0, 4).Select(d => d + 1F).Take(4);
                var a = line.Item1;
                var b = line.Item2;
                g.DrawLine(
                    ratio + ratio * (float)a.X,
                    ratio + ratio * (float)a.Y,
                    ratio + ratio * (float)b.X,
                    ratio + ratio * (float)b.Y, s);
            }

            var style = new FigureStyle();
            style.Area.Size = new SizeF(7F, 7F);
            style.Pen.Brush.Color = Color.Black;
            foreach (var point in collection)
            {
                g.DrawPlot(
                    ratio + ratio * (float)point.Item1,
                    ratio + ratio * (float)point.Item2, style);
            }


            s_special.DashPattern = new[] { 1F, 19F };
            int max = 6;
            for (int i = 1 ; i < max ; ++i)
            {
                g.DrawLine(max * ratio, i * ratio, 0, i * ratio, s_special);
                g.DrawLine(i * ratio, max * ratio, i * ratio, 0, s_special);
            }

            return meta;
        }
    }
}
