﻿using System;
using System.Drawing;
using System.Linq;
using CharMY.Drawing;
using CharMY.Numerics.Matrixes;

namespace CharMY.Sample
{
    partial class Sample
    {
        //色空間3Dグラフの描画

        [STAThread]
        public static void Main()
        {
            var rand = new Random();
            var fig = Sequence.Loop()
                .Select(i =>
                {
                    var lab = new SpatialVector(
                        rand.NextDouble() * 100,
                        rand.NextDouble() * 1000 - 500,
                        rand.NextDouble() * 1000 - 500);
                    var xyz = lab.LabsToCieXyz50();
                    var c = xyz.CieXyz50TosRgb();
                    return new
                    {
                        lab,
                        c
                    };
                })
                .Where(obj => obj.c.A > 1)
                .Take(500)
                .Chart3DPlot(
                    obj => obj.lab.Z,
                    obj => obj.lab.Y,
                    obj => obj.lab.X,
                    xLabel: "b*",
                    yLabel: "a*",
                    zLabel: "L*",
                    style: (obj, s) => s.Brush.Color = obj.c);

            fig.Format.LegendStyle.Area.Size = new SizeF(6, 6);
            fig.Creator.Axes.X().MaximumValue = 100;
            fig.Creator.Axes.X().MinimumValue = -100;
            fig.Creator.Axes.Y().MaximumValue = 100;
            fig.Creator.Axes.Y().MinimumValue = -100;
            fig.Creator.Axes.X().Format.Options |= ChartAxialFormatOptions.NoScaleSubLines;
            fig.Creator.Axes.Y().Format.Options |= ChartAxialFormatOptions.NoScaleSubLines;
            fig.Creator.Axes.Z().Format.Options |= ChartAxialFormatOptions.NoScaleSubLines;
            fig.Creator.ParametersFor3DVision.SetDefaultType(Graphics3DParameters.DefaultType.VerticalZView);
            fig.Creator.ParametersFor3DVision.ModeStereo = true;

            fig.Create3DVisualizer()
                .ImageView()
                .ShowDialog();
        }
    }
}
